

Option Strict On ' Create one of these to keep track of someone's statuses
' Since one person can be both a student and/or staff and/or faculty and/or administrator

' The static (Shared) functions allow for each mapping to user-readable text

Public Class StatusTracker
    Private m_flags As Boolean() = New Boolean(3) {}

    Public Function StatusFlags(ByVal i As Integer) As Boolean
        Return m_flags(i)
    End Function

    Public Sub StatusFlags(ByVal i As Integer, ByVal b As Boolean)
        m_flags(i) = b
    End Sub


    ' could have done this next part w/ a Module, but
    ' it seems less confusing to have everything in one spot
    Private Shared m_strings As String() = New String(3) {"Student", "Staff", "Faculty", "Administration"}

    Public Shared Function StatusText(ByVal i As Integer) As String
        Return m_strings(i)
    End Function

End Class

Public Enum Status
    STUDENT = 0
    STAFF
    FACULTY
    ADMINISTRATION
End Enum

Public Enum LengthOfEmployment
    LessThanAYear
    OneToTwoYears
    TwoToThreeYears
    ThreeToFourYears
    MoreThanFourYears
End Enum